QGIS Application - Bug report #8421

"import delimited text layer" does not work with files created on excel/osx

2013-08-07 08:58 AM - Arthur Vignacq

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/Delimited Text

Affected QGIS version:master
Operating System: 0sX

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: end of life

Copied to github as #: 17190

Description

Hello,

| just tried to import a CSV file in QGIS 1.9 master. But even if | select ; as the separator factor, QGIS just think everything is on the same

row.

The import of the same file work very well in 1.8

Cheers

History

#1 - 2013-08-07 09:01 AM - Giovanni Manghi
- Status changed from Open to Feedback

did you choose custom delimiter -> semicolon?

#2 - 2013-08-08 12:23 AM - Arthur Vignacq

Giovanni Manghi wrote:

did you choose custom delimiter -> semicolon?

I don't have this option. In custom delimiter | can choose between; "," "tab" "space’

colon"and ";"

Neither work. All the content is place in 1st row. the exact same file with same procedure work fine in 1.8

#3 - 2013-08-08 01:03 AM - Giovanni Manghi
- File 58.png added

Arthur Vignacq wrote:

Giovanni Manghi wrote:

did you choose custom delimiter -> semicolon?
I don't have this option. In custom delimiter | can choose between; "," "tab" "space" "colon" and ";"

Neither work. All the content is place in 1st row. the exact same file with same procedure work fine in 1.8

see attached image.

PS

Are you sure you are running the latest master release?

#4 - 2013-08-08 01:55 AM - Arthur Vignacq
- File CSV.tiff added

Yes, | think it's the last release as | downloaded it yesterday (Mac osX).

My visual attached.

#5 - 2013-08-08 01:57 AM - Giovanni Manghi

Arthur Vignacq wrote:

Yes, | think it's the last release as | downloaded it yesterday (Mac 0sX).

My visual attached.

please attach a sample of you data

#6 - 2013-08-08 02:05 AM - Arthur Vignacq
- File XY _Ports_VNF.csv added

please see attached file

#7 - 2013-08-08 02:34 AM - Regis Haubourg

Your field nom as sometime text delimiters, sometimes not. Could you try to export csv with another tool and see if it changes something?
I had many troubles here to export correctly csv for all possible cases (encoding, decimal delimiter, text delimiter.. )

#8 - 2013-08-08 02:56 AM - Giovanni Manghi

regis Haubourg wrote:

Your field nom as sometime text delimiters, sometimes not. Could you try to export csv with another tool and see if it changes something?
I had many troubles here to export correctly csv for all possible cases (encoding, decimal delimiter, text delimiter.. )

saving the file to libreoffice calc and then resaving it as csv make the resulting file work. My guess is that there is something wrong on how the file was
originally created, | remember that the OsX for example had problems of this kind.

#9 - 2013-08-08 11:36 AM - Giovanni Manghi

The issue seems to be this one

http://developmentality.wordpress.com/2010/12/06/excel-2008-for-macs-csv-bug/

giovanni@sibirica ~/Downloads $ file XY_Ports_VNF.csv
XY_Ports_VNF.csv: ASCII text, with CR line terminators

when resaved with libreoffice

giovanni@sibirica ~/Downloads $ file test2.csv
test2.csv: ASCII text

please check and report back.

#10 - 2013-08-09 01:11 AM - Arthur Vignacq

The weird thing, is that QGIS 1.8, perfectly read this same file with the possible mistake office mac made.

I'll try it with the 2011 version of Microsoft office in few minutes

#11 - 2013-08-09 02:00 AM - Giovanni Manghi

Arthur Vignacq wrote:

The weird thing, is that QGIS 1.8, perfectly read this same file with the possible mistake office mac made.

the tool has been completely rewritten, so no surprise that now works this way.

#12 - 2013-08-09 02:54 AM - Arthur Vignacq

Just used Office 2011. Same problem when saved as .. "csv "

Re-tried with a save as " windows _ csv". This time QGIS read it fine.

Although 3 element coming with 2x " at beginning and ending of name ? I've seen no reason for that.

#13 - 2013-08-09 03:11 AM - Regis Haubourg

Those with quotes are cells that contain carriage returns it seems.

Carriage returns an csv are really a mess. After large testing, we now use here xlIs 2003 as a pivot format for attribute data. (but it needs good cleaning (no
formula, no encoded field names).

In my theorical roadmap, | would like to fund refactoring of vector layer dialog to give impor options and preview, just like csv plugin, but for all data types.
that would help. Anyway, csv and carriage return will always be a mess since there is no CSV norm..

#14 - 2013-08-09 04:07 AM - Giovanni Manghi
regis Haubourg wrote:

Anyway, csv and carriage return will always be a mess since there is no CSV norm..

Then | would propose to close this ticket, or eventually make it low priority and change its title (please propose something).

#15 - 2013-09-20 01:10 AM - Giovanni Manghi

- Category set to C++ Plugins

- Operating System set to osx

- Target version set to Future Release - High Priority

- Subject changed from CSV import QGIS not understanding ; as separator to "import delimited text layer" does not work with files created on excel/osx

#16 - 2014-03-26 11:27 AM - Alexander Bruy
- Category changed from C++ Plugins to Data Provider/Delimited Text

#17 - 2014-04-17 01:12 PM - John Tull
I don't know if this could present a potential solution, but you could use dos2unix (i.e., 'dos2unix -c mac foo.csv') to preprocess cdv files on OSX. For the
uninitiated, trying to add csv layers with mac line encodings causes qgis to freeze requiring a force quit. Using dos2unix would add a dependency for the

mac platform, but this seems preferable to crashing the program when using a feature that is pretty commonly needed.

To implement, there would need to be an OS check to force OSX to run this operation. | can only assume that this is doable. FWIW, dos2unix is available

via homebrew.

http://waterlan.home.xs4all.nl/dos2unix.html

#18 - 2014-05-15 04:00 AM - mac joost

For me, the issue importing CSV files on a Mac is that the importer doesn't support the default mac "record separator” (the line ending).

On a mac, the default line eding is CR (carriage return).

Unix line endings (LF: line feed) and Windows line endings (CRLF) are supported.

Changing the line ending of your csv file to eg. CR will make QGIS import the file just fine (I used TextWrangler).

It would be nice though if the importer could just support CR line endings or have it configurable.

#19 - 2014-06-23 07:28 AM - Giovanni Manghi

- Status changed from Feedback to Open

#20 - 2014-11-29 08:59 PM - Dewey Dunnington

| realize this issue is over 5 months old, but I'm about to use QGIS to teach a GIS short course to 40 or so people who will use it for various basic biology

and geology map making and some basic analysis. | managed to convince our department to choose QGIS instead of Arc because it's become stable and

for anything we use it for on a daily basis it does everything we need. This particular issue is a major, major stumbling block in getting people to adopt the

program, because the easiest way to get our field data into QGIS is by making a csv. Anybody with a mac in our department (which is almost everybody)

does this with Excel 2008 or 2011, which both have the problem of separating lines with carriage returns instead of newline characters. It seems as though

this issue is an extraordinarily easy fix (separate lines by \

2024-03-13 4/6


http://waterlan.home.xs4all.nl/dos2unix.html

\

, then by \

, then by \

), and | realize there are more exciting features and developers only have so much time. However, | would just like to reiterate how important this very

simple issue is to the adoption of QGIS. Nobody in our department can use the beautiful new symbology editor if they can't get their data into the program.

#21 - 2014-12-22 01:14 AM - Benjamin Warr

| repeat the plea made by Dewey. The standard or 'default' encoding for csv imports appears to be UTF-8, please can someone ensure that csv imports

can be made on macs's !

#22 - 2014-12-22 05:22 AM - Giovanni Manghi

Benjamin Warr wrote:

| repeat the plea made by Dewey. The standard or ‘default' encoding for csv imports appears to be UTF-8, please can someone ensure that csv

imports can be made on macs's !

If this fix is so vital for you (and in general for Mac users) then please consider supporting its fix.

#23 - 2014-12-22 06:01 AM - Benjamin Warr

Hi Giovanni, my apologies for a newbie question, but | am not sure how to "support the fix".

Ben

#24 - 2014-12-22 06:38 AM - Giovanni Manghi

Benjamin Warr wrote:

Hi Giovanni, my apologies for a newbie question, but | am not sure how to "support the fix".

Ben

Hire a developer, see for example

http://qgis.org/en/site/forusers/commercial_support.html

#25 - 2017-05-01 01:09 AM - Giovanni Manghi
- Regression? set to No
- Easy fix? set to No

#26 - 2019-03-09 04:04 PM - Giovanni Manghi
- Status changed from Open to Closed
- Resolution set to end of life

End of life notice: QGIS 2.18 LTR
Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

Files

58.png 184 KB 2013-08-07 Giovanni Manghi
CSV.tiff 1.22 MB 2013-08-07 Arthur Vignacq
XY_Ports_VNF.csv 748 Bytes 2013-08-08 Arthur Vignacq
